#ifdef GL_ES
precision mediump int;
precision mediump float;
#endif

#define USE_OGRE_FROM_FUTURE
#include <OgreUnifiedShader.h>

OGRE_UNIFORMS(
uniform mat4 worldViewProj;
uniform vec4 texelOffsets;
uniform vec4 inColor;
)

MAIN_PARAMETERS
IN(vec4 vertex, POSITION)
OUT(vec4 oColor, TEXCOORD0)
OUT(vec2 oDepth, TEXCOORD1)
MAIN_DECLARATION
{
  vec4 pos = mul(worldViewProj, vertex);  
  pos.xy += texelOffsets.zw * vec2_splat(pos.w);  
  gl_Position = pos;
  
  oColor = inColor;
  oDepth = pos.zw;
}