// Need to enable the draw buffers extension
#if defined(OGRE_GLSL) || defined(OGRE_GLSLES)
#extension GL_ARB_draw_buffers : enable 
#endif

#ifdef GL_ES
precision mediump int;
precision mediump float;
#endif

#define USE_OGRE_FROM_FUTURE
#include <OgreUnifiedShader.h>

vec4 pack(float value)
{
  vec4 shift = vec4(256.0 * 256.0 * 256.0, 256.0 * 256.0, 256.0, 1.0);
  vec4 mask = vec4(0.0, 1.0 / 256.0, 1.0 / 256.0, 1.0 / 256.0);
  vec4 ret = fract(vec4_splat(value) * shift);
  ret -= ret.xxyz * mask;
  return ret.wzyx;
}

MAIN_PARAMETERS
IN(vec4 oColor, TEXCOORD0)
IN(vec2 oDepth, TEXCOORD1)
MAIN_DECLARATION_DATA
{
  gl_FragColor0 = oColor;  
  gl_FragColor1 = pack(oDepth.x / oDepth.y);
}
